using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using OnlineExam.Entities;

namespace OnlineExam.Mapping
{
	public class AttendanceMap : EntityTypeConfiguration<Attendance>
	{
		public AttendanceMap()
		{
			// Primary Key
			this.HasKey(t => t.ID);

			// Properties
			this.Property(t => t.Score)
				.IsRequired();
				
			// Table & Column Mappings
			this.ToTable("Attendances");
			this.Property(t => t.ID).HasColumnName("ID");
			this.Property(t => t.ExamID).HasColumnName("ExamID");
			this.Property(t => t.UserID).HasColumnName("UserID");
			this.Property(t => t.StartedAt).HasColumnName("StartedAt");
			this.Property(t => t.EndedAt).HasColumnName("EndedAt");
			this.Property(t => t.Status).HasColumnName("Status");
			this.Property(t => t.Score).HasColumnName("Score");
			this.Property(t => t.CreatedAt).HasColumnName("CreatedAt");
			this.Property(t => t.UpdatedAt).HasColumnName("UpdatedAt");

			// Relationships
			this.HasRequired(t => t.Exam)
				.WithMany(t => t.Attendances)
				.HasForeignKey(d => d.ExamID);
				
			this.HasRequired(t => t.User)
				.WithMany(t => t.Attendances)
				.HasForeignKey(d => d.UserID);
				
		}
	}
}

