using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using OnlineExam.Entities;

namespace OnlineExam.Mapping
{
	public class CategoryMap : EntityTypeConfiguration<Category>
	{
		public CategoryMap()
		{
			// Primary Key
			this.HasKey(t => t.ID);

			// Properties
			this.Property(t => t.Taxonomy)
				.IsRequired()
				.HasMaxLength(50);
				
			this.Property(t => t.Name)
				.IsRequired()
				.HasMaxLength(50);
				
			// Table & Column Mappings
			this.ToTable("Categories");
			this.Property(t => t.ID).HasColumnName("ID");
			this.Property(t => t.Taxonomy).HasColumnName("Taxonomy");
			this.Property(t => t.Name).HasColumnName("Name");
			this.Property(t => t.ParentID).HasColumnName("ParentID");
		}
	}
}

