using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using OnlineExam.Entities;

namespace OnlineExam.Mapping
{
	public class PaperMetaMap : EntityTypeConfiguration<PaperMeta>
	{
		public PaperMetaMap()
		{
			// Primary Key
			this.HasKey(t => t.ID);

			// Properties
			this.Property(t => t.MetaKey)
				.IsRequired()
				.HasMaxLength(256);
				
			this.Property(t => t.MetaValue)
				.IsRequired();
				
			// Table & Column Mappings
			this.ToTable("PaperMetas");
			this.Property(t => t.ID).HasColumnName("ID");
			this.Property(t => t.PaperID).HasColumnName("PaperID");
			this.Property(t => t.MetaKey).HasColumnName("MetaKey");
			this.Property(t => t.MetaValue).HasColumnName("MetaValue");

			// Relationships
			this.HasRequired(t => t.Paper)
				.WithMany(t => t.PaperMetas)
				.HasForeignKey(d => d.PaperID);
				
		}
	}
}

