using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using OnlineExam.Entities;

namespace OnlineExam.Mapping
{
	public class ProblemMap : EntityTypeConfiguration<Problem>
	{
		public ProblemMap()
		{
			// Primary Key
			this.HasKey(t => t.ID);

			// Properties
			this.Property(t => t.Body)
				.IsRequired();
				
			// Table & Column Mappings
			this.ToTable("Problems");
			this.Property(t => t.ID).HasColumnName("ID");
			this.Property(t => t.CategoryID).HasColumnName("CategoryID");
			this.Property(t => t.Body).HasColumnName("Body");
			this.Property(t => t.Type).HasColumnName("Type");
			this.Property(t => t.CreatedAt).HasColumnName("CreatedAt");
			this.Property(t => t.UpdatedAt).HasColumnName("UpdatedAt");

			// Relationships
			this.HasRequired(t => t.Category)
				.WithMany(t => t.Problems)
				.HasForeignKey(d => d.CategoryID);
				
		}
	}
}

